// 4 Dec 2006 : Coding by Simone Mannori
//              ScicosHIL porting under Windows
//              First working code :)
//
// 7 Dec 2006 : Final 1.0 version 

/* Include files */

#include <windows.h>                    /* Compiler's include files's */
#include <string.h>

#include <stdlib.h>
#include <stdio.h>

#include "scicos_block.h"  /* Specific for scicos block developement */
#include "machine.h"

#include "cbw.h"           /* Specific for MC USB devices  */ 
 
#define Init           4   /* Initialization */ 
#define OutputUpdate   1
#define StateUpdate    2
#define Integration    0
#define Mode           9    /* Zero Crossing */
#define EventScheduler 3
#define Ending         5   
 
 //** static structure inside block->work  
  typedef struct {    
	/* Variable Declarations */
    int BoardNum ;
    int UDStat   ;
    int Chan     ;
	int range    ; //** 0-7 range selection progressive id (as Comedi)
	int Range    ; //** symbolic otput gain for DA output
  } McUsbAnOut ;

void analog_output(scicos_block *block, int flag) 
{
  McUsbAnOut *AOdata ; //** define the local datastructure 

  double u[1]               ;
  float EngUnits            ; 
  unsigned short DataValue  ;

  float RevLevel = (float)CURRENTREVNUM;
      
  switch(flag) {  
      
      case Init: //** Card and port init   
         *block->work = (McUsbAnOut *) scicos_malloc(sizeof(McUsbAnOut));
         if (*block->work  == NULL ) 
           { //** in case of error exit 
	         set_block_error(-16); return; //** --> Exit point  
           }
         AOdata = (McUsbAnOut *) *block->work; //** map the local structure in the scicos_block user data 
	 
	     
         AOdata->BoardNum = 0 ; // the first board of  CB.CFG  
         AOdata->Chan  = block->ipar[0]  ; // channel selection  
		 AOdata->Range = UNI4VOLTS       ; // the output gain is fixed   
		 
         EngUnits = 0.0 ; //** zero on the output 
		 // int cbFromEngUnits(int BoardNum, int Range, float EngUnits, unsigned short *DataVal)
		 AOdata->UDStat = cbFromEngUnits(AOdata->BoardNum, AOdata->Range, EngUnits, &DataValue) ;
         // int cbAOut( int BoardNum, int Channel, int Range, unsigned short DataValue )
         AOdata->UDStat = cbAOut(AOdata->BoardNum, AOdata->Chan, AOdata->Range, DataValue ) ;
         
		 /* Declare UL Revision Level */
         AOdata->UDStat = cbDeclareRevision(&RevLevel);

         /* Initiate error handling
         Parameters:
            PRINTALL :all warnings and errors encountered will be printed
            DONTSTOP :program will continue even if error occurs.
                      Note that STOPALL and STOPFATAL are only effective in 
                      Windows applications, not Console applications. 
         */
          cbErrHandling (PRINTALL, DONTSTOP);

		 // Commented out because is too time comsuming for the Init of many blocks
		 // AOdata->UDStat = cbFlashLED (AOdata->BoardNum); //** Blink the greeen led ;) 
      break; 
      
      case StateUpdate:
          AOdata = (McUsbAnOut *) *block->work;
	      u[0] = block->inptr[0][0] ; //** get the input from Scilab/Scicos 
	      
		  if ( u[0] < 0 ) 
	        u[0] = 0 ; //** lower saturation  
	      if ( u[0] > 4.095 ) 
	        u[0] = 4.095 ; //** upper saturation
          
		  EngUnits = (float)u[0] ; //** get the limited input 
		  // int cbFromEngUnits(int BoardNum, int Range, float EngUnits, unsigned short *DataVal)
		  AOdata->UDStat = cbFromEngUnits(AOdata->BoardNum, AOdata->Range, EngUnits, &DataValue) ;
          // int cbAOut( int BoardNum, int Channel, int Range, unsigned short DataValue )
          AOdata->UDStat = cbAOut(AOdata->BoardNum, AOdata->Chan, AOdata->Range, DataValue ) ;
      break;
      
      case Ending:
          AOdata = (McUsbAnOut *) *block->work;
          EngUnits = 0.0 ; //** zero on the output 
		  // int cbFromEngUnits(int BoardNum, int Range, float EngUnits, unsigned short *DataVal)
		  AOdata->UDStat = cbFromEngUnits(AOdata->BoardNum, AOdata->Range, EngUnits, &DataValue) ;
          // int cbAOut( int BoardNum, int Channel, int Range, unsigned short DataValue )
          AOdata->UDStat = cbAOut(AOdata->BoardNum, AOdata->Chan, AOdata->Range, DataValue ) ;
      break;	  
        
  } // close the switch
   
} // close the function 

