// 4 Dec 2006 : Coding by Simone Mannori
//              ScicosHIL porting under Windows
//              First working code :) 
//
// 7 Dec 2006 : Final 1.0 version 
//** -------------------------- DIGITAL INPUT -------------------------------
// 
// The two (Port A, Port B) digital I/O are bit addressable but each port MUST BE
// configured as ALL outputs OR inputs: no mixed input/output bit on the same port
// are allowed (see usb-1208FS.c and usb-1208FS.h for the details). Please group
// all the inputs on a port and all the outputs on the other port. Two output port 
// and two input ports configurations are allowed.
/* Include files */

#include <windows.h>                    /* Compiler's include files's */
#include <string.h>

#include <stdlib.h>
#include <stdio.h>

#include "scicos_block.h"  /* Specific for scicos block developement */
#include "machine.h"

#include "cbw.h"           /* Specific for MC USB devices  */ 
 
#define Init           4   /* Initialization */ 
#define OutputUpdate   1
#define StateUpdate    2
#define Integration    0
#define Mode           9    /* Zero Crossing */
#define EventScheduler 3
#define Ending         5   

 //** static structure inside block->work  
  typedef struct {
    int BoardNum  ;
    int UDStat    ;
    int PortNum   ;
	int Direction ;
	int Channel   ;
  } McUsbDigIn ;

void digital_input(scicos_block *block, int flag) 
{
  McUsbDigIn *DIdata ; //** define the local datastructure 
  
  unsigned int chan , portsel , portdir ; //**   
  unsigned short DataValue ;
  unsigned int bitmask   ;
  unsigned int portinput ; 

  switch(flag) {  
      
      case Init: //** Card and port init   
        *block->work = (McUsbDigIn *) scicos_malloc(sizeof(McUsbDigIn));
        if (*block->work  == NULL ) 
          { //** in case of error exit 
	         set_block_error(-16); return; //** --> Exit point  
          }
	    DIdata = (McUsbDigIn *) *block->work; //** map the local structure in the scicos_block user data  
        
        DIdata->BoardNum = 0 ;
	    chan    = block->ipar[0] ; // channel selection  
        portsel = block->ipar[1] ; //** 0->Port A, 1->Port B 
	    portdir = block->ipar[2] ; //** 0->ALL Inputs, 1->ALL Outputs  

		//** int cbDConfigPort(int BoardNum, int PortNum, int Direction)
		// int PortNum   : FIRSTPORTA FIRSTPORTB 
		// int Direction : DIGITALIN  DIGITALOUT
		
        DIdata->Channel = chan ; 

		if (portsel==0)
			 DIdata->PortNum = FIRSTPORTA ;
		if (portsel==1)
			 DIdata->PortNum = FIRSTPORTB ;
        
		if (portdir==0)
			 DIdata->Direction = DIGITALIN ;
		if (portdir==1)
			 DIdata->Direction = DIGITALOUT ;

        DIdata->UDStat = cbDConfigPort(DIdata->BoardNum, DIdata->PortNum, DIdata->Direction);
	    
		// Commented out because is too time comsuming for the Init of many blocks
		// DIdata->UDStat = cbFlashLED (DIdata->BoardNum); //** Blink the greeen led ;)
       break; 
//==============================================================================================================

      case OutputUpdate:
        DIdata = (McUsbDigIn *) *block->work;
	
        // int cbDIn (int BoardNum, int PortNum, unsigned short *DataValue)
		DIdata->UDStat = cbDIn (DIdata->BoardNum, DIdata->PortNum, &DataValue);
        bitmask = 1   ;
	    bitmask = bitmask << DIdata->Channel ;
	    portinput = (unsigned int) DataValue ;
	    portinput = portinput & bitmask    ;
	
	    if (portinput == 0 )
	         block->outptr[0][0] = (double) 0.0 ; //** low state 
	    else
	         block->outptr[0][0] = (double) 1.0 ; //** high state 
	
      break;
//===============================================================================================================      
      case Ending:
           DIdata = (McUsbDigIn *) *block->work;
           // do nothing 
      break;	  
        
  } // close the switch
   
} // close the function 

